import { ChangeDetectorRef, ComponentFactoryResolver, EventEmitter, QueryList, Type, ViewContainerRef } from "@angular/core";
import { UntypedFormGroup } from "@angular/forms";
import { DynamicFormArrayGroupModel, DynamicFormControl, DynamicFormControlContainerComponent, DynamicFormControlEvent, DynamicFormControlModel, DynamicFormComponentService, DynamicFormLayout, DynamicFormLayoutService, DynamicFormRelationService, DynamicFormValidationService, DynamicTemplateDirective, DynamicFormArrayComponent, DynamicFormControlLayout, DynamicFormArrayModel, DynamicFormControlCustomEvent, DynamicFormGroupComponent, DynamicFormGroupModel } from "@danielhokanson/ng-dynamic-forms-core";
import * as i0 from "@angular/core";
export declare class DynamicBasicFormControlContainerComponent extends DynamicFormControlContainerComponent {
    protected changeDetectorRef: ChangeDetectorRef;
    protected componentFactoryResolver: ComponentFactoryResolver;
    protected layoutService: DynamicFormLayoutService;
    protected validationService: DynamicFormValidationService;
    protected componentService: DynamicFormComponentService;
    protected relationService: DynamicFormRelationService;
    contentTemplateList: QueryList<DynamicTemplateDirective>;
    klass?: string;
    context: DynamicFormArrayGroupModel | null;
    group: UntypedFormGroup;
    hostClass?: string[];
    inputTemplateList: QueryList<DynamicTemplateDirective>;
    layout?: DynamicFormLayout;
    model: DynamicFormControlModel;
    blur: EventEmitter<DynamicFormControlEvent>;
    change: EventEmitter<DynamicFormControlEvent>;
    focus: EventEmitter<DynamicFormControlEvent>;
    componentViewContainerRef: ViewContainerRef;
    constructor(changeDetectorRef: ChangeDetectorRef, componentFactoryResolver: ComponentFactoryResolver, layoutService: DynamicFormLayoutService, validationService: DynamicFormValidationService, componentService: DynamicFormComponentService, relationService: DynamicFormRelationService);
    get componentType(): Type<DynamicFormControl> | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicBasicFormControlContainerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicBasicFormControlContainerComponent, "dynamic-basic-form-control", never, { "context": { "alias": "context"; "required": false; }; "group": { "alias": "group"; "required": false; }; "hostClass": { "alias": "hostClass"; "required": false; }; "inputTemplateList": { "alias": "templates"; "required": false; }; "layout": { "alias": "layout"; "required": false; }; "model": { "alias": "model"; "required": false; }; }, { "blur": "blur"; "change": "change"; "focus": "focus"; }, ["contentTemplateList"], ["*"], true, never>;
}
export declare function basicUIFormControlMapFn(model: DynamicFormControlModel): Type<DynamicFormControl> | null;
export declare class DynamicBasicFormArrayComponent extends DynamicFormArrayComponent {
    protected layoutService: DynamicFormLayoutService;
    protected validationService: DynamicFormValidationService;
    formLayout?: DynamicFormLayout;
    group: UntypedFormGroup;
    layout?: DynamicFormControlLayout;
    model: DynamicFormArrayModel;
    templates?: QueryList<DynamicTemplateDirective>;
    blur: EventEmitter<any>;
    change: EventEmitter<any>;
    customEvent: EventEmitter<DynamicFormControlCustomEvent>;
    focus: EventEmitter<any>;
    components: QueryList<DynamicBasicFormControlContainerComponent>;
    constructor(layoutService: DynamicFormLayoutService, validationService: DynamicFormValidationService);
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicBasicFormArrayComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicBasicFormArrayComponent, "dynamic-basic-form-array", never, { "formLayout": { "alias": "formLayout"; "required": false; }; "group": { "alias": "group"; "required": false; }; "layout": { "alias": "layout"; "required": false; }; "model": { "alias": "model"; "required": false; }; "templates": { "alias": "templates"; "required": false; }; }, { "blur": "blur"; "change": "change"; "customEvent": "customEvent"; "focus": "focus"; }, never, never, true, never>;
}
export declare class DynamicBasicFormGroupComponent extends DynamicFormGroupComponent {
    protected layoutService: DynamicFormLayoutService;
    protected validationService: DynamicFormValidationService;
    formLayout?: DynamicFormLayout;
    group: UntypedFormGroup;
    layout?: DynamicFormControlLayout;
    model: DynamicFormGroupModel;
    templates?: QueryList<DynamicTemplateDirective> | DynamicTemplateDirective[];
    blur: EventEmitter<any>;
    change: EventEmitter<any>;
    customEvent: EventEmitter<DynamicFormControlCustomEvent>;
    focus: EventEmitter<any>;
    components: QueryList<DynamicFormControlContainerComponent>;
    constructor(layoutService: DynamicFormLayoutService, validationService: DynamicFormValidationService);
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicBasicFormGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicBasicFormGroupComponent, "dynamic-basic-form-group", never, { "formLayout": { "alias": "formLayout"; "required": false; }; "group": { "alias": "group"; "required": false; }; "layout": { "alias": "layout"; "required": false; }; "model": { "alias": "model"; "required": false; }; "templates": { "alias": "templates"; "required": false; }; }, { "blur": "blur"; "change": "change"; "customEvent": "customEvent"; "focus": "focus"; }, never, never, true, never>;
}
